<template>
  <div class="pagination">
    <a href="javascript:void(0)" @click="prevPage"
       class="pagination__item pagination__arrow pagination__arrow--prev"
       :class="{'pagination__arrow--hidden': page === 1 }"
    >
      <icon-pagination-arrow class="pagination__icon"/>
    </a>

    <a
      href="javascript:void(0)"
      v-for="item in pageCount"
      :key="item"
      :class="{'pagination__item--active': page === item }"
      class="pagination__item"
      @click="selectPage(item)"
    >
      {{ item }}
    </a>

    <a href="javascript:void(0)" @click="nextPage"
       class="pagination__item pagination__arrow pagination__arrow--next"
       :class="{'pagination__arrow--hidden': page === pageCount }"
    >
      <icon-pagination-arrow class="pagination__icon"/>
    </a>

  </div>
</template>

<script>
  import IconPaginationArrow from '../components/icons/IconPaginationArrow';

  export default {
    name: 'Pagination',
    model: {
      prop: 'page'
    },
    props: {
      page: {
        type: Number,
        required: true
      },

      perPage: {
        type: Number,
        required: true
      },

      total: {
        type: Number,
        required: true
      }
    },
    components: {
      IconPaginationArrow
    },
    computed: {
      pageCount() {
        return Math.ceil(this.total / this.perPage)
      }
    },
    methods: {
      prevPage() {
        const pageNum = this.page - 1;

        if (pageNum > 0) {
          this.selectPage(pageNum);
        }
      },
      nextPage() {
        const pageNum = this.page + 1;

        if (pageNum <= this.pageCount) {
          this.selectPage(pageNum);
        }
      },

      selectPage(page) {
        this.$emit('input', page);
      }

    }
  }
</script>

<style lang="scss">
  @import '~assets/scss/variables.scss';
  @import '~assets/scss/mixins.scss';

  .pagination {
    display: flex;
    align-items: center;
    justify-content: center;

    &__item {
      &:not(.pagination__arrow) {
        & + & {
          margin-left: rem(20);
        }

        &:not(.pagination__item--active) {
          &:hover {
            color: $black;
          }
        }
      }

      @include gray-btn;
      @include p1;

      display: flex;
      align-items: center;
      justify-content: center;

      width: rem(40);
      height: rem(40);
      padding: 0;

      color: $dark-gray;

      border-radius: 50%;
      cursor: pointer;

      &--active {
        @include green-btn;
        color: $white;

        &:active {
          box-shadow: none;
        }
      }

      &:active:not(.pagination__item--active) {
        @include gray-btn-active;
      }
    }

    &__arrow {
      &:hover {
        svg {
          stroke: $black;
        }
      }

      &--prev {
        margin-right: rem(40);

        .pagination__icon {
          transform: rotate(180deg);
        }
      }

      &--next {
        margin-left: rem(40);
      }

      &--hidden {
        visibility: hidden;
      }
    }

  }
</style>
